Skip to content
geeksforgeeks
  • Courses
    • DSA to Development
    • Get IBM Certification
    • Newly Launched!
      • Master Django Framework
      • Become AWS Certified
    • For Working Professionals
      • Interview 101: DSA & System Design
      • Data Science Training Program
      • JAVA Backend Development (Live)
      • DevOps Engineering (LIVE)
      • Data Structures & Algorithms in Python
    • For Students
      • Placement Preparation Course
      • Data Science (Live)
      • Data Structure & Algorithm-Self Paced (C++/JAVA)
      • Master Competitive Programming (Live)
      • Full Stack Development with React & Node JS (Live)
    • Full Stack Development
    • Data Science Program
    • All Courses
  • Tutorials
    • Data Structures & Algorithms
    • ML & Data Science
    • Interview Corner
    • Programming Languages
    • Web Development
    • CS Subjects
    • DevOps And Linux
    • School Learning
  • Practice
    • Build your AI Agent
    • GfG 160
    • Problem of the Day
    • Practice Coding Problems
    • GfG SDE Sheet
  • Contests
    • Accenture Hackathon (Ending Soon!)
    • GfG Weekly [Rated Contest]
    • Job-A-Thon Hiring Challenge
    • All Contests and Events
  • DSA
  • Interview Problems on DP
  • Practice DP
  • MCQs on DP
  • Tutorial on Dynamic Programming
  • Optimal Substructure
  • Overlapping Subproblem
  • Memoization
  • Tabulation
  • Tabulation vs Memoization
  • 0/1 Knapsack
  • Unbounded Knapsack
  • Subset Sum
  • LCS
  • LIS
  • Coin Change
  • Word Break
  • Egg Dropping Puzzle
  • Matrix Chain Multiplication
  • Palindrome Partitioning
  • DP on Arrays
  • DP with Bitmasking
  • Digit DP
  • DP on Trees
  • DP on Graph
Open In App
Next Article:
Allocate Minimum Pages
Next article icon

The Painter’s Partition Problem using Binary Search

Last Updated : 29 Apr, 2025
Comments
Improve
Suggest changes
Like Article
Like
Report
Try it on GfG Practice
redirect icon

Given an array arr[] and k, where the array represents the boards and each element of the given array represents the length of each board. k numbers of painters are available to paint these boards. Consider that each unit of a board takes 1 unit of time to paint.
The task is to find the minimum time to get this job done by painting all the boards under the constraint that any painter will only paint the continuous sections of boards. say board [2, 3, 4] or only board [1] or nothing but not board [2, 4, 5].

Examples: 

Input: arr[] = [5, 10, 30, 20, 15], k = 3
Output: 35
Explanation: The most optimal way will be:
Painter 1 allocation : [5,10]
Painter 2 allocation : [30]
Painter 3 allocation : [20, 15]
Job will be done when all painters finish i.e. at time = max(5 + 10, 30, 20 + 15) = 35

Input: arr[] = [10, 20, 30, 40], k = 2
Output: 60
Explanation: The most optimal way to paint:
Painter 1 allocation : [10, 20, 30]
Painter 2 allocation : [40]
Job will be complete at time = 60

Input: arr[] = [100, 200, 300, 400], k = 1
Output: 1000

In the Painter’s Partition Problem, we’ve previously explored a dynamic programming based approach with a time complexity of O(k*(n^2)) and an extra space of O(k*n). In this article, we present a more optimized solution using Binary Search, significantly improving the overall efficiency.

Approach:

The idea is based on the observation that if we fix a time limit (say mid), we can check whether it’s possible to divide the boards among k painters such that no one paints for more than this time. We apply Binary Search on the answer space to minimize the maximum time taken by any painter.

  • The highest possible value in this range is the sum of all elements in the array – this represents the case when one painter paints all the boards.
  • The lowest possible value is the maximum element of the array – this ensures at least one painter paints the largest board, and others are assigned workloads not exceeding this value.
  • For each mid value, we simulate the partitioning and check if it’s feasible using the given number of painters.
  • As the time limit increases, the number of painters required decreases, and vice versa. This monotonic property ensures the search space is ordered, making it ideal for binary search.
C++
// C++ program to find the minimum time for // painter's partition problem using Binary Search. #include <bits/stdc++.h> using namespace std;  // Function to check if it is possible to  // paint all boards by k painters such that no  // painter paints  more than maxTime bool isPossible(int maxTime, vector<int> &arr, int k) {      int painters = 1;     int currSum = 0;      for (int i = 0; i < arr.size(); i++) {          // If a single board exceeds maxTime,         // return false         if (arr[i] > maxTime) {             return false;         }          // If adding current board exceeds          // limit, assign to next painter         if (currSum + arr[i] > maxTime) {             painters++;             currSum = arr[i];         } else {             currSum += arr[i];         }     }      // Return true if total painters used is <= k     return painters <= k; }  int minTime(vector<int> &arr, int k) {      int n = arr.size();      // Find the maximum board length manually     int maxBoard = arr[0];     for (int i = 1; i < n; i++) {         if (arr[i] > maxBoard) {             maxBoard = arr[i];         }     }      // Find the sum of all board lengths manually     int totalSum = 0;     for (int i = 0; i < n; i++) {         totalSum += arr[i];     }      // Apply Binary Search between      // maxBoard and totalSum     int low = maxBoard;     int high = totalSum;     int res = totalSum;      while (low <= high) {         int mid = (low + high) / 2;          // If it is possible with max workload as mid         if (isPossible(mid, arr, k)) {             res = mid;                          // try to minimize further             high = mid - 1;          } else {                           // need more time             low = mid + 1;          }     }      return res; }  int main() {     vector<int> arr = {5, 10, 30, 20, 15};     int k = 3;     int res = minTime(arr, k);     cout << res << endl;      return 0; } 
Java
// Java program to find the minimum time for // painter's partition problem using Binary Search.  class GfG {      // Function to check if it is possible to      // paint all boards by k painters such that no      // painter paints  more than maxTime     static boolean isPossible(int maxTime, int[] arr, int k) {          int painters = 1;         int currSum = 0;          for (int i = 0; i < arr.length; i++) {              // If a single board exceeds maxTime,             // return false             if (arr[i] > maxTime) {                 return false;             }              // If adding current board exceeds              // limit, assign to next painter             if (currSum + arr[i] > maxTime) {                 painters++;                 currSum = arr[i];             } else {                 currSum += arr[i];             }         }          // Return true if total painters used is <= k         return painters <= k;     }      static int minTime(int[] arr, int k) {          int n = arr.length;          // Find the maximum board length manually         int maxBoard = arr[0];         for (int i = 1; i < n; i++) {             if (arr[i] > maxBoard) {                 maxBoard = arr[i];             }         }          // Find the sum of all board lengths manually         int totalSum = 0;         for (int i = 0; i < n; i++) {             totalSum += arr[i];         }          // Apply Binary Search between          // maxBoard and totalSum         int low = maxBoard;         int high = totalSum;         int res = totalSum;          while (low <= high) {             int mid = (low + high) / 2;              // If it is possible with max workload as mid             if (isPossible(mid, arr, k)) {                 res = mid;                                  // try to minimize further                 high = mid - 1;              } else {                                   // need more time                 low = mid + 1;              }         }          return res;     }      public static void main(String[] args) {         int[] arr = {5, 10, 30, 20, 15};         int k = 3;         int res = minTime(arr, k);         System.out.println(res);     } } 
Python
# Python program to find the minimum time for # painter's partition problem using Binary Search.  def isPossible(maxTime, arr, k):      painters = 1     currSum = 0      for i in range(len(arr)):          # If a single board exceeds maxTime,         # return false         if arr[i] > maxTime:             return False          # If adding current board exceeds          # limit, assign to next painter         if currSum + arr[i] > maxTime:             painters += 1             currSum = arr[i]         else:             currSum += arr[i]      # Return true if total painters used is <= k     return painters <= k   def minTime(arr, k):      n = len(arr)      # Find the maximum board length manually     maxBoard = arr[0]     for i in range(1, n):         if arr[i] > maxBoard:             maxBoard = arr[i]      # Find the sum of all board lengths manually     totalSum = 0     for i in range(n):         totalSum += arr[i]      # Apply Binary Search between      # maxBoard and totalSum     low = maxBoard     high = totalSum     res = totalSum      while low <= high:         mid = (low + high) // 2          # If it is possible with max workload as mid         if isPossible(mid, arr, k):             res = mid              # try to minimize further             high = mid - 1         else:              # need more time             low = mid + 1      return res   if __name__ == "__main__":     arr = [5, 10, 30, 20, 15]     k = 3     res = minTime(arr, k)     print(res) 
C#
// C# program to find the minimum time for // painter's partition problem using Binary Search. using System;  class GfG {      // Function to check if it is possible to      // paint all boards by k painters such that no      // painter paints  more than maxTime     static bool isPossible(int maxTime, int[] arr, int k) {          int painters = 1;         int currSum = 0;          for (int i = 0; i < arr.Length; i++) {              // If a single board exceeds maxTime,             // return false             if (arr[i] > maxTime) {                 return false;             }              // If adding current board exceeds              // limit, assign to next painter             if (currSum + arr[i] > maxTime) {                 painters++;                 currSum = arr[i];             } else {                 currSum += arr[i];             }         }          // Return true if total painters used is <= k         return painters <= k;     }      static int minTime(int[] arr, int k) {          int n = arr.Length;          // Find the maximum board length manually         int maxBoard = arr[0];         for (int i = 1; i < n; i++) {             if (arr[i] > maxBoard) {                 maxBoard = arr[i];             }         }          // Find the sum of all board lengths manually         int totalSum = 0;         for (int i = 0; i < n; i++) {             totalSum += arr[i];         }          // Apply Binary Search between          // maxBoard and totalSum         int low = maxBoard;         int high = totalSum;         int res = totalSum;          while (low <= high) {             int mid = (low + high) / 2;              // If it is possible with max workload as mid             if (isPossible(mid, arr, k)) {                 res = mid;                                  // try to minimize further                 high = mid - 1;              } else {                                   // need more time                 low = mid + 1;              }         }          return res;     }      static void Main() {         int[] arr = {5, 10, 30, 20, 15};         int k = 3;         int res = minTime(arr, k);         Console.WriteLine(res);     } } 
JavaScript
// JavaScript program to find the minimum time for // painter's partition problem using Binary Search.  function isPossible(maxTime, arr, k) {      let painters = 1;     let currSum = 0;      for (let i = 0; i < arr.length; i++) {          // If a single board exceeds maxTime,         // return false         if (arr[i] > maxTime) {             return false;         }          // If adding current board exceeds          // limit, assign to next painter         if (currSum + arr[i] > maxTime) {             painters++;             currSum = arr[i];         } else {             currSum += arr[i];         }     }      // Return true if total painters used is <= k     return painters <= k; }  function minTime(arr, k) {      let n = arr.length;      // Find the maximum board length manually     let maxBoard = arr[0];     for (let i = 1; i < n; i++) {         if (arr[i] > maxBoard) {             maxBoard = arr[i];         }     }      // Find the sum of all board lengths manually     let totalSum = 0;     for (let i = 0; i < n; i++) {         totalSum += arr[i];     }      // Apply Binary Search between      // maxBoard and totalSum     let low = maxBoard;     let high = totalSum;     let res = totalSum;      while (low <= high) {         let mid = Math.floor((low + high) / 2);          // If it is possible with max workload as mid         if (isPossible(mid, arr, k)) {             res = mid;                          // try to minimize further             high = mid - 1;          } else {                           // need more time             low = mid + 1;          }     }      return res; }  // Driver Code let arr = [5, 10, 30, 20, 15]; let k = 3; let res = minTime(arr, k); console.log(res); 

Output
35 

Time Complexity: O(n*log(sum(arr) – MAX)), as we perform Binary Search on the answer space from maximum board length to total sum, and for each mid value, we iterate over all n boards to check feasibility.
Space Complexity: O(1), as the approach uses constant space.



Next Article
Allocate Minimum Pages

R

rsatish1110
Improve
Article Tags :
  • Competitive Programming
  • Divide and Conquer
  • DSA
  • Dynamic Programming
  • Searching
  • Binary Search
  • Codenation
  • Google
Practice Tags :
  • Codenation
  • Google
  • Binary Search
  • Divide and Conquer
  • Dynamic Programming
  • Searching

Similar Reads

  • Binary Search Algorithm - Iterative and Recursive Implementation
    Binary Search Algorithm is a searching algorithm used in a sorted array by repeatedly dividing the search interval in half. The idea of binary search is to use the information that the array is sorted and reduce the time complexity to O(log N). Conditions to apply Binary Search Algorithm in a Data S
    15 min read
  • What is Binary Search Algorithm?
    Binary Search is a searching algorithm used in a sorted array by repeatedly dividing the search interval in half and the correct interval to find is decided based on the searched value and the mid value of the interval. Properties of Binary Search:Binary search is performed on the sorted data struct
    1 min read
  • Time and Space Complexity Analysis of Binary Search Algorithm
    Time complexity of Binary Search is O(log n), where n is the number of elements in the array. It divides the array in half at each step. Space complexity is O(1) as it uses a constant amount of extra space. AspectComplexityTime ComplexityO(log n)Space ComplexityO(1)The time and space complexities of
    3 min read
  • How to calculate "mid" or Middle Element Index in Binary Search?
    The most common method to calculate mid or middle element index in Binary Search Algorithm is to find the middle of the highest index and lowest index of the searchable space, using the formula mid = low + \frac{(high - low)}{2} Is this method to find mid always correct in Binary Search? Consider th
    6 min read
  • Variants of Binary Search

    • Variants of Binary Search
      Binary search is very easy right? Well, binary search can become complex when element duplication occurs in the sorted list of values. It's not always the "contains or not" we search using Binary Search, but there are 5 variants such as below:1) Contains (True or False) 2) Index of first occurrence
      15+ min read

    • Meta Binary Search | One-Sided Binary Search
      Meta binary search (also called one-sided binary search by Steven Skiena in The Algorithm Design Manual on page 134) is a modified form of binary search that incrementally constructs the index of the target value in the array. Like normal binary search, meta binary search takes O(log n) time. Meta B
      9 min read

    • The Ubiquitous Binary Search | Set 1
      We are aware of the binary search algorithm. Binary search is the easiest algorithm to get right. I present some interesting problems that I collected on binary search. There were some requests on binary search. I request you to honor the code, "I sincerely attempt to solve the problem and ensure th
      15+ min read

    • Uniform Binary Search
      Uniform Binary Search is an optimization of Binary Search algorithm when many searches are made on same array or many arrays of same size. In normal binary search, we do arithmetic operations to find the mid points. Here we precompute mid points and fills them in lookup table. The array look-up gene
      7 min read

    • Randomized Binary Search Algorithm
      We are given a sorted array A[] of n elements. We need to find if x is present in A or not.In binary search we always used middle element, here we will randomly pick one element in given range.In Binary Search we had middle = (start + end)/2 In Randomized binary search we do following Generate a ran
      13 min read

    • Abstraction of Binary Search
      What is the binary search algorithm? Binary Search Algorithm is used to find a certain value of x for which a certain defined function f(x) needs to be maximized or minimized. It is frequently used to search an element in a sorted sequence by repeatedly dividing the search interval into halves. Begi
      7 min read

    • N-Base modified Binary Search algorithm
      N-Base modified Binary Search is an algorithm based on number bases that can be used to find an element in a sorted array arr[]. This algorithm is an extension of Bitwise binary search and has a similar running time. Examples: Input: arr[] = {1, 4, 5, 8, 11, 15, 21, 45, 70, 100}, target = 45Output:
      10 min read

    Implementation of Binary Search in different languages

    • C Program for Binary Search
      In this article, we will understand the binary search algorithm and how to implement binary search programs in C. We will see both iterative and recursive approaches and how binary search can reduce the time complexity of the search operation as compared to linear search. Table of Content What is Bi
      7 min read

    • C++ Program For Binary Search
      Binary Search is a popular searching algorithm which is used for finding the position of any given element in a sorted array. It is a type of interval searching algorithm that keep dividing the number of elements to be search into half by considering only the part of the array where there is the pro
      5 min read

    • C Program for Binary Search
      In this article, we will understand the binary search algorithm and how to implement binary search programs in C. We will see both iterative and recursive approaches and how binary search can reduce the time complexity of the search operation as compared to linear search. Table of Content What is Bi
      7 min read

    • Binary Search functions in C++ STL (binary_search, lower_bound and upper_bound)
      In C++, STL provide various functions like std::binary_search(), std::lower_bound(), and std::upper_bound() which uses the the binary search algorithm for different purposes. These function will only work on the sorted data. There are the 3 binary search function in C++ STL: Table of Content binary_
      3 min read

    • Binary Search in Java
      Binary search is a highly efficient searching algorithm used when the input is sorted. It works by repeatedly dividing the search range in half, reducing the number of comparisons needed compared to a linear search. Here, we are focusing on finding the middle element that acts as a reference frame t
      7 min read

    • Binary Search (Recursive and Iterative) - Python
      Binary Search Algorithm is a searching algorithm used in a sorted array by repeatedly dividing the search interval in half. The idea of binary search is to use the information that the array is sorted and reduce the time complexity to O(log N). Below is the step-by-step algorithm for Binary Search:
      6 min read

    • Binary Search In JavaScript
      Binary Search is a searching technique that works on the Divide and Conquer approach. It is used to search for any element in a sorted array. Compared with linear, binary search is much faster with a Time Complexity of O(logN), whereas linear search works in O(N) time complexity Examples: Input : ar
      3 min read

    • Binary Search using pthread
      Binary search is a popular method of searching in a sorted array or list. It simply divides the list into two halves and discards the half which has zero probability of having the key. On dividing, we check the midpoint for the key and use the lower half if the key is less than the midpoint and the
      8 min read

    Comparison with other Searching

    • Linear Search vs Binary Search
      Prerequisite: Linear SearchBinary SearchLINEAR SEARCH Assume that item is in an array in random order and we have to find an item. Then the only way to search for a target item is, to begin with, the first position and compare it to the target. If the item is at the same, we will return the position
      11 min read

    • Interpolation search vs Binary search
      Interpolation search works better than Binary Search for a Sorted and Uniformly Distributed array. Binary Search goes to the middle element to check irrespective of search-key. On the other hand, Interpolation Search may go to different locations according to search-key. If the value of the search-k
      7 min read

    • Why is Binary Search preferred over Ternary Search?
      The following is a simple recursive Binary Search function in C++ taken from here. C/C++ Code // CPP program for the above approach #include <bits/stdc++.h> using namespace std; // A recursive binary search function. It returns location of x in // given array arr[l..r] is present, otherwise -1
      11 min read

  • Binary Search Intuition and Predicate Functions
    The binary search algorithm is used in many coding problems, and it is usually not very obvious at first sight. However, there is certainly an intuition and specific conditions that may hint at using binary search. In this article, we try to develop an intuition for binary search. Introduction to Bi
    12 min read
  • Can Binary Search be applied in an Unsorted Array?
    Binary Search is a search algorithm that is specifically designed for searching in sorted data structures. This searching algorithm is much more efficient than Linear Search as they repeatedly target the center of the search structure and divide the search space in half. It has logarithmic time comp
    9 min read
  • Find a String in given Array of Strings using Binary Search
    Given a sorted array of Strings arr and a string x, The task is to find the index of x in the array using the Binary Search algorithm. If x is not present, return -1. Examples: Input: arr[] = {"contribute", "geeks", "ide", "practice"}, x = "ide"Output: 2Explanation: The String x is present at index
    6 min read
geeksforgeeks-footer-logo
Corporate & Communications Address:
A-143, 7th Floor, Sovereign Corporate Tower, Sector- 136, Noida, Uttar Pradesh (201305)
Registered Address:
K 061, Tower K, Gulshan Vivante Apartment, Sector 137, Noida, Gautam Buddh Nagar, Uttar Pradesh, 201305
GFG App on Play Store GFG App on App Store
Advertise with us
  • Company
  • About Us
  • Legal
  • Privacy Policy
  • In Media
  • Contact Us
  • Advertise with us
  • GFG Corporate Solution
  • Placement Training Program
  • Languages
  • Python
  • Java
  • C++
  • PHP
  • GoLang
  • SQL
  • R Language
  • Android Tutorial
  • Tutorials Archive
  • DSA
  • Data Structures
  • Algorithms
  • DSA for Beginners
  • Basic DSA Problems
  • DSA Roadmap
  • Top 100 DSA Interview Problems
  • DSA Roadmap by Sandeep Jain
  • All Cheat Sheets
  • Data Science & ML
  • Data Science With Python
  • Data Science For Beginner
  • Machine Learning
  • ML Maths
  • Data Visualisation
  • Pandas
  • NumPy
  • NLP
  • Deep Learning
  • Web Technologies
  • HTML
  • CSS
  • JavaScript
  • TypeScript
  • ReactJS
  • NextJS
  • Bootstrap
  • Web Design
  • Python Tutorial
  • Python Programming Examples
  • Python Projects
  • Python Tkinter
  • Python Web Scraping
  • OpenCV Tutorial
  • Python Interview Question
  • Django
  • Computer Science
  • Operating Systems
  • Computer Network
  • Database Management System
  • Software Engineering
  • Digital Logic Design
  • Engineering Maths
  • Software Development
  • Software Testing
  • DevOps
  • Git
  • Linux
  • AWS
  • Docker
  • Kubernetes
  • Azure
  • GCP
  • DevOps Roadmap
  • System Design
  • High Level Design
  • Low Level Design
  • UML Diagrams
  • Interview Guide
  • Design Patterns
  • OOAD
  • System Design Bootcamp
  • Interview Questions
  • Inteview Preparation
  • Competitive Programming
  • Top DS or Algo for CP
  • Company-Wise Recruitment Process
  • Company-Wise Preparation
  • Aptitude Preparation
  • Puzzles
  • School Subjects
  • Mathematics
  • Physics
  • Chemistry
  • Biology
  • Social Science
  • English Grammar
  • Commerce
  • World GK
  • GeeksforGeeks Videos
  • DSA
  • Python
  • Java
  • C++
  • Web Development
  • Data Science
  • CS Subjects
@GeeksforGeeks, Sanchhaya Education Private Limited, All rights reserved
We use cookies to ensure you have the best browsing experience on our website. By using our site, you acknowledge that you have read and understood our Cookie Policy & Privacy Policy
Lightbox
Improvement
Suggest Changes
Help us improve. Share your suggestions to enhance the article. Contribute your expertise and make a difference in the GeeksforGeeks portal.
geeksforgeeks-suggest-icon
Create Improvement
Enhance the article with your expertise. Contribute to the GeeksforGeeks community and help create better learning resources for all.
geeksforgeeks-improvement-icon
Suggest Changes
min 4 words, max Words Limit:1000

Thank You!

Your suggestions are valuable to us.

What kind of Experience do you want to share?

Interview Experiences
Admission Experiences
Career Journeys
Work Experiences
Campus Experiences
Competitive Exam Experiences